// NEW VERSION OF PDFMAP   2011,12,17
// ----------------------------------
// assumed cols > rows, if not, turn pic 90 degree by yourself
// bar_data should seperate from comment chars, two_ends keep clean.
// input *.bmp, color_plate in 0~255 grey grades.
// MAX_pdf: 90 bar_code *34 block      ( PDF417 stardard, 2+30+2 )
// MAX_pixel:  4096*1024
// 12.17-18  add pic_blend adjust

#include <stdio.h>
#include <string.h>
#define UNINW       99               // for background sharpness
#define max_uninw  140
#define n1        4096               // max cols
#define n2        1024               // max rows
#define n3          90               // max bar_number
#define expixel    560               // expand pic thresh.
#define p54         54               // 9 points energy
#define reduce20     3                                         // 20111223

#define XP           1               // xp or linux
unsigned char obits[n2][n1];         // raw data
unsigned char  bits[n2][n1];         // processing pic
unsigned char  btmp[n2][n1];         // temp array
unsigned char   bar[n3][n1];         // raw bar
unsigned char  sbar[n3][n1];         // adjust bar, center_line
unsigned char  sba1[n3][n1];         // adjust bar, up_line
unsigned char  sba2[n3][n1];         // adjust bar, down_line
unsigned char  tbar[n3][17*34+1];    // save bar
unsigned short    h[539],th[549];    // BMP head 27+512  raw,save head
#define  o      255                  // following is pdf417 left_right code
unsigned char h1[17]={o,o,o,o,o,o,o,o,0,o,0,o,0,o,0,0,0};
unsigned char h2[18]={o,o,o,o,o,o,o,0,o,0,0,0,o,0,o,0,0,o};
int work[n1],work1[n1],work2[n1];
int w2[n2];                          // y_dir: Sigma_I(bits[j+1][i]-bits[j][i])
int xbar[34];                        // x_dir: each block position
int ybar[n3];                        // y_dir: each code  position
int bargap,total,nblock,jbar,ibar;   // jbar: n_line_code, ibar===17*nblock+1
int start;                           // sbar-->tbar,  0 0 0 start ... [cols]
int rows,cols,oldrows;
int u1,u2,v1,v2,z1,z2,zz;            // 1st corner position of pixel
int x1,x2,x3,x4,y1,y2,y3,y4;         // 2nd corner position of bits file
int uninw,dunin;
int times;
int black,white;                     // to see a pic, black enough ? (if=0)
int trace[30*15]; ntrace;            // 34-2 * 17-2

float f2,f3,f4,f5;             // f2: scale, f3: temp,
FILE *fp,*fp1;
char sb[80],sf[80];                  // file name
int P=1;                             // display or not
int nomap=0;                         // un-do file to "nomap DIR"
int outpic=2;                        // 1: with blank line around
int iturn;
int ak[17];                          // temp
int reduce;

corner(u,v,x,y,zx,zy)                // input: u,v; output: x,y
int u,v,zx,zy, *x,*y;                // zx,zy  4 corner direction
{
  int i,j,k,p,q,r,s,t;
  for(r=0;r<rows/4*3;r++)for(j=0;j<=r;j++)for(i=0;i<=r;i++)if(i+j==r){
    s=u+i*zx; t=v+j*zy;
    if(s<0)s=0; if(s>cols-1)s=cols-1;
    if(t<0)t=0; if(t>rows-1)t=rows-1;
    if(bits[t][s]){  k=0;
      for(q=0;q<10;q+=2)for(p=0;p<5;p++)if(bits[t+q*zy][s+p*zx])k++;
      if(k>=22)goto l10;             // allowed apear 3 0 in 25 data
    }
  }
l10:                           // distance 3 pixel of corner. find X,Y edge
  s+=zx*3; t+=zy*3;
  for(j=0;j<8;j++){ q=t-j*zy; if(q<0 || q>=rows-1)break; if(!bits[q][s])break; }
  for(i=0;i<8;i++){ p=s-i*zx; if(p<0 || p>=cols-1)break; if(!bits[t][p])break; }
  *x=p+zx;  *y=q+zy;
}

alone()                            // delete alone pointer, need 2 times
{
  int i,j,k;
  for(k=0;k<2;k++){
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
    for(j=1;j<rows-1;j++)for(i=1;i<cols-1;i++){
      if(bits[j][i]){
        if((btmp[j][i-1]|btmp[j][i+1])==0)bits[j][i]=0;
        if((btmp[j-1][i]|btmp[j+1][i])==0)bits[j][i]=0;
      }
    }
  }
}

getybar(w2,n,ybar,jbar,w)
int *w2,n,*ybar,*jbar,*w;
{
  int i,j,k,i1,i2,f,it=0;
  int d1=600000, d2=0;
  float x,y;
// take n/4 ~~~ n/4*3 data, get low, high_level.
  k=(y2-y1)/4; i1=y1+k; i2=y2-k;
  for(i=i1;i<i2;i++){ if(w2[i]>d2)d2=w2[i]; if(w2[i]<d1)d1=w2[i]; }
//printf("low,high: %d %d\n",d1,d2);
  x=20./(d2-d1);
l00:             it++;
  for(i=0;i<n;i++)w[i]=w2[i];
  for(i=0;i<n;i++){ j=(w[i]-d1)*x; if(j>15)j=15; if(j<6)j=0; w[i]=j; }
// status 0 numbers
  k=0; for(i=y1;i<=y2;i++)if(w[i]==0)k++;
  y=y2-y1;  y=k/y;
//printf("%d %f %f\n",k,y,x);
  if(y>0.6 && it<3){ x*=1.3;  goto l00;}       // adjust gray level
  if(y<0.4 && it<3){ x/=1.3;  goto l00;}

//  printf("**%d\n",it); for(i=0;i<50;i++)printf("%d",i%10); printf("\n");
//  for(i=0;i<n;i++){ if(i%50==0)printf("\n"); printf("%x",w[i]); }
//  printf("y1,y3,%d %d y2,n %d %d\n",y1,y3,y2,n);

  j=k=it=0; f=6;  if(y2-y1>99)f=8;
  while(w[j]==0)j++; while(w[j])j++;      // jump header
l10:       it++;  if(it>50)goto l20;      // avoid dead_loop
  while(w[j]==0)j--;                        i1=j; d1=w[j]; j++;
  while(w[j]==0){ j++; if(j>=n)goto l20; }  i2=j; d2=w[j];
  i=(i2-i1)/2+i1;
  ybar[k++]=i;         if(k>30)goto l20;  // avoid  dead_loop
  if(k>1){ j=(ybar[k-1]-ybar[k-2])/2;
    if(j>=f-1){ ybar[k-1]=i-j;  ybar[k++]=i; }   // insert one
    f=(ybar[k-1]-ybar[0])/(k-1);
  } else if(i2-i1>f)f=i2-i1+2;
  if(f<5)f=5;   i=10;  j=ybar[k-1]+f;
  while(w[j]&&i){ i--; if(w[j-1]>w[j+1])j++; else j--; }
  if(j<=y2)goto l10;
l20:
//for(i=0;i<k;i++)printf("%d ",ybar[i]); printf(" %d %d\n",y2,rows);
// delete flase  OR add one
  while(ybar[k-1]==ybar[k-2])k--;         // delete false
  if(k>5){
    x=ybar[k-2]-ybar[1];  x/=(k-3);
    j=ybar[k-2]+x+0.5; if(j>y2)k--;       // delete last one
    j=ybar[1]-(x+0.5); if(j<y1){  k--;
      for(i=0;i<k;i++)ybar[i]=ybar[i+1];
//    printf(" delet 1st_bar !\n");
    }
    j=ybar[0]-x;
    if(j>y1 && w[j] ){ k++;
//      printf(" add 1st_bar !\n");
      for(i=k-1;i>0;i--)ybar[i]=ybar[i-1];  ybar[0]=ybar[1]-x;
    }
    j=y2-ybar[k-1];
    if(j>x){
//     printf(" add last_bar !\n");
       ybar[k]=ybar[k-1]+(x-0.5);  k++;
    }
  }
// adjust 1st_position
  if(ybar[1]-ybar[0]>x && k>5 )ybar[0]=ybar[1]-x+0.5;
//for(i=0;i<k;i++)printf("%d ",ybar[i]); printf(" %d %d\n",y2,rows);
  *jbar=k;
}

expand2(int i1,int i2)            // expand pic to 2*2 times size.
{                                 // & sharpness background
  int i,j,k;
  for(j=0;j<rows;j++)for(i=i1;i<=i2;i++)btmp[j][i-i1]=bits[j][i];
  rows=rows*2-1; cols=(i2-i1)*2+1;  h[9]=cols; h[11]=rows;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=0;
  for(j=0;j<rows;j+=2)for(i=0;i<cols;i+=2)bits[j][i]=btmp[j/2][i/2];
  if(P)printf("PICsize changed: %d*%d\n",cols,rows);
  for(j=1;j<rows;j+=2)for(i=0;i<cols;i+=2)
                    bits[j][i]=(bits[j-1][i]>>1)+(bits[j+1][i]>>1);
  for(j=0;j<rows;j+=2)for(i=1;i<cols;i+=2)
                    bits[j][i]=(bits[j][i-1]>>1)+(bits[j][i+1]>>1);
  for(j=1;j<rows;j+=2)for(i=1;i<cols;i+=2){
      k=bits[j-1][i-1]+bits[j-1][i+1]+bits[j+1][i-1]+bits[j+1][i+1];
      bits[j][i]=k>>2;
  }                                              // use uninw sharpness
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(!bits[j][i])bits[j][i]=0;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)obits[j][i]=255-bits[j][i];
}

int readp(char *a, char *b, int m, int *j)
{
  int i; for(i=0;i<m;i++)if(a[i]!=b[i])break;
  sscanf(&a[10],"%d",j);  return i/m;
}

readpar()
{
  int j,k;
  fp=fopen("c://pdf417.par","r");
  if(fp){ k=0;
l01:
    fgets(sb,80,fp);  if(feof(fp))goto l02;      // # pdfmap
    if(sb[0]=='#'){ if(k==1)goto l02; if(sb[5]=='m')k=1; goto l01; }
    if(sb[0]<=32 || k==0)goto l01;               // allowed blank_line
    if(k){                                       // no matter of order
      if(readp(sb,"print",5,&j))P=j;
      if(readp(sb,"nomap",5,&j))nomap=j;
      if(readp(sb,"outpic",6,&j))outpic=j;
    }
    goto l01;
l02: fclose(fp);
    if(outpic<0)outpic=0; if(outpic>4)outpic=4;
    if(P)printf("par:\tnomap %d outpic %d\n",nomap,outpic);
    outpic*=2;
  }
}

#define nph 3
phead[nph]={ 51111152,51111251,41111144 };
pdfswap(u,v)
int *u,*v;
{
  int i,j,k,d,l;
  j=0; k=17; d=1; l=255; *u=*v=0;
  for(i=1;i<17;i++)if(tbar[j][i+k]==l)d++; else { d=d*10+1; l=255-l;}
  for(i=0;i<nph;i++)if(d==phead[i])return;
  j=jbar-1; k=17; d=1; l=255; *u=1;
  for(i=1;i<17;i++)if(tbar[j][i+k]==l)d++; else { d=d*10+1; l=255-l;}
  for(i=0;i<nph;i++)if(d==phead[i])return;
  j=0; k=(nblock-2)*17; d=1; l=255; *v=1; *u=0;
  for(i=1;i<17;i++)if(tbar[j][i+k]==l)d++; else { d=d*10+1; l=255-l;}
  for(i=0;i<nph;i++)if(d==phead[i])return;
  j=jbar-1; k=(nblock-2)*17; d=1; l=255; *u=1;
  for(i=1;i<17;i++)if(tbar[j][i+k]==l)d++; else { d=d*10+1; l=255-l;}
  for(i=0;i<nph;i++)if(d==phead[i])return;
  *u=*v=0;
}

pre_black_edge()
{
  int i,j;
  for(j=0;j<rows;j++){
    for(i=0;i<cols;i++)if(obits[j][i]>UNINW)break; else obits[j][i]=255;
    for(i=cols-1;i>0;i--)if(obits[j][i]>UNINW)break; else obits[j][i]=255;
  }
}

false_corner(int *w2)
{                                     // different method of old version
  int i,j,k=0,ii,jj,kx=0,ky=0;        // add find 4 middle point of each edge
  int im1,im2,jm1,jm2;                // middle position     2011,12
  ii=x1-x2-x3+x4;  if(ii<0)ii=-ii;
  jj=y1-y2-y3+y4;  if(jj<0)jj=-jj;    // *w2, temp only

  if(ii+jj<5)goto l98;                // need not adjust
// find im1,im2
  im1=u1; im2=u2; j=(v2+v1)/2;
  while(!bits[j][im1])im1++;
  while(!bits[j][im2])im2--;
  jm1=jm2=j;
  i=(u1+u2)/2;
  for(j=v1;j<=v2;j++){ w2[j]=0;
    for(k=i-20;k<=i+20;k++)if(bits[j][k]>UNINW)w2[j]++;
  }
  w2[j]=0; j=v1-1; if(j<0)j=0; w2[j]=0;
//for(i=0;i<=v2;i++)printf("%d ",w2[i]); printf("\n");
  while(w2[jm1])jm1--; jm1++;
  while(w2[jm2])jm2++; jm2--;
//  printf("ii,jj: %d %d\n",ii,jj);
//  printf("x1,im1,x2_x3,im2,x4:  %d %d %d_ %d %d %d\n",x1,im1,x2,x3,im2,x4);
//  printf("y1,jm1,y3_y2,jm2,y4:  %d %d %d_ %d %d %d\n",y1,jm1,y3,y2,jm2,y4);
  if(ii>=jj)kx=jf6(x1,im1,x2,x3,im2,x4);
  if(ii<=jj){ ky=jf6(y1,jm1,y3,y2,jm2,y4);  if(ky==2 || ky==3)ky=5-ky; }
  k=ky?ky:kx;
l98:
//according:  x1-x2=x3-x4;   y1-y2=y3-y4;
  if(k==1){ z1=x2+x3-x4; z2=y2+y3-y4; }
  if(k==2){ z1=x1+x4-x3; z2=y1+y4-y3; }
  if(k==3){ z1=x1+x4-x2; z2=y1+y4-y2; }
  if(k==4){ z1=x2+x3-x1; z2=y2+y3-y1; }
  if(k&P)printf("false_corner: %d *****u,v: %d %d\n",k,z1,z2);
  return k;
}

jf6(z1,z12,z2,z3,z34,z4)
int z1,z12,z2,z3,z34,z4;
{
  int i,j,k,k1,k2,j1,j2;
// jduge z1_z2 error. or z3_z4
  k1=z1+z2-z12*2;  if(k1<0)k1=-k1;
  k2=z3+z4-z34*2;  if(k2<0)k2=-k2;
  if(k1>k2){
    j=(z3-z4)/2;   k=1;
    j1=z1-z12-j;
    j2=z12-z2-j;
  } else {
    j=(z1-z2)/2;   k=3;
    j1=z3-z34-j;
    j2=z34-z4-j;
  }
  if(j1<0)j1=-j1;
  if(j2<0)j2=-j2;
  if(j1<j2)k++;
//  printf("k1,k2: %d %d j1,j2: %d %d   k: %d\n",k1,k2,j1,j2,k);
  return k;
}

if4_4(a,b,v,u)                         // check & modify 17_bar
int *a,*b,v,u;                         // a   row data
{                                      // b   power of point
  int i,j,m,r,it=0;
  float x;                             // INT_type cannot express.
l10:      it++; if(it>9)goto l99;
  j=255;  x=1;
  for(i=1;i<17;i++)if(a[i]==j)x++; else { x=x*10.+1; j=255-j;}
  if(x<1000000.){    m=r=0;   reduce++;   // lost bar
//  printf("%d %d:%12.0f\n",v,u,x);
//  for(i=0;i<17;i++)printf("%3d ",a[i]); printf("\n");
//  for(i=0;i<17;i++)printf("%3d ",b[i]); printf("\n");
    for(i=2;i<16;i++)if(a[i] || a[i-1] || a[i+1] || b[i]==0) continue;
    else { if(b[i]>r){ r=b[i]; m=i; } }
    if(m){ a[m]=255;  goto l10; }           // white --> black
    r=99;
    for(i=1;i<15;i++)if(a[i]==0 || a[i-1]==0 || a[i+1]==0)continue;
    else { if(b[i]<r){ r=b[i]; m=i; } }
    a[m]=b[m]=0;      goto l10;             // black --> white
  }
l20:
  if(x>100000000.){  m=r=0;  reduce++;     // more bar
//  printf("%d %d:%14.0f\n",v,u,x);
//  for(i=0;i<17;i++)printf("%3d ",b[i]); printf("\n");
//  for(i=0;i<17;i++)printf("%3d ",a[i]); printf("\n");
    for(i=1;i<16;i++)if(a[i] || b[i]==0)continue;
    else { if(b[i]>r){ r=b[i]; m=i; } }
    if(m){ a[m]=255; goto l10; }
    r=99;
    for(i=2;i<16;i++)if(a[i]==0 || a[i-1] || a[i+1])continue;
    else { if(b[i]<r){ r=b[i]; m=i; } }
    a[m]=b[m]=0;      goto l10;            // black --> white
  }
l99:
  m=x;
  return (m);
}


median(b)
int *b;
{
  int i,j,k,a[5];
  for(i=0;i<5;i++)a[i]=b[i];
  for(i=0;i<4;i++)for(j=i+1;j<5;j++)if(a[i]>a[j]){
    k=a[i]; a[i]=a[j]; a[j]=k;  }
  return(a[2]);
}

median_line(a,i1,i2)
int *a,i1,i2;
{
  int i;
  for(i=i1;i<=i2;i++)work2[i]=a[i];
  for(i=i1+2;i<=i2-2;i++)a[i]=median(&work2[i-2]);
}


// blend pic adjust:  ( shape: arc or s_type )
// after find 4 corner
// x1,y1, -- x3,y3  link a  line
// get some black points, "out of"  standard_line,
// make a curve .
// also do x2,y2--x4,y4 same job
// using curve modify pic, vertical data array, moving  up or down,
// then do getybar ...  no y_slip adjust again.
wave_adjust()
{
  int i,j,k,m,km,i1,i2,k1,k2;
  float f;
// grey grade
  k=255-white*2+UNINW;                           // white: 127~ 100
  for(j=0;j<rows;j++)for(i=0;i<cols;i++){
    m=(bits[j][i]-k)/16; if(m<0)m=0; btmp[j][i]=m; }
  i1=x1; if(i1<x2)i1=x2;
  i2=x3; if(i2>x4)i2=x4;
  f=(y3-y1); f/=(x3-x1);
//for(i=cols/4;i<cols/2;i++){
//for(j=rows*3/4;j<rows;j++)printf("%x",btmp[j][i]); printf("\n"); }
// up_line
  for(i=i1;i<=i2;i++){
    j=y1+f*(i-x1);
    if(btmp[j][i]){                   // up
      k=j-1; while(btmp[k][i])k--;
      work[i]=k;
    } else {                          // search down
      for(k=j;k<j+30;k++)if(btmp[k][i])break;
      work[i]=k-1;
    }
  }
// down_line
  f=(y4-y2); f/=(x4-x2);
  for(i=i1;i<=i2;i++){
    j=y2+f*(i-x2);
    if(btmp[j][i]){                   // down
      k=j+1; while(btmp[k][i])k++;
      work1[i]=k;
    } else {
      for(k=j;k>j-30;k--)if(btmp[k][i])break;
      work1[i]=k+1;
    }
  }
// fill curve
  j=0;  m=i1;
  for(i=i1+1;i<i2;i++){               // equal delete  some peaks
    if(j==2)j++;
    k=work[i]-work[i-1];
    if(j==3){ f=work[i]-km; f/=(i-m);
//           printf("km,work[],f: %d %d %f\n",km,work[i],f);
             if(f>0.5 || f<-0.5){work[i]=km; f=0; }
              for(j=m;j<=i;j++)work[j]=km+f*(j-m); j=0;}
    if(j==1){ if(k)continue; if(work[i]-km>3)continue; j++; }
    if(k> 1){ m=i-2; km=work[m]; j++; }
  }
  j=0;  m=i1;
  for(i=i1+1;i<i2;i++){
    if(j==2)j++;
    k=work1[i]-work1[i-1];
    if(j==3){ f=work1[i]-km; f/=(i-m);
//           printf("km,work[],f: %d %d %f\n",km,work1[i],f);
             if(f>0.5 || f<-0.5){work[i]=km; f=0; }
              for(j=m;j<=i;j++)work1[j]=km+f*(j-m);j=0;}
    if(j==1){ if(k)continue; if(work1[i]-km<-3)continue; j++; }
    if(k<-1){ m=i-2; km=work1[m]; j++; }
  }
// median & qulity
  for(i=0;i<=i2;i++)work[i]-=y1;  median_line(work,i1,i2);
  k1=0; for(i=i1+3;i<i2-4;i++)
        { j=work[i+1]-work[i]; if(j<0)j=-j; if(j==1)j=0;  k1+=j; }
  for(i=0;i<=i2;i++)work1[i]-=y2; median_line(work1,i1,i2);
  k2=0; for(i=i1+3;i<i2-4;i++)
        { j=work1[i+1]-work1[i]; if(j<0)j=-j; if(j==1)j=0;  k2+=j; }
// choice which curver.
  if(k1 && k2){
    f=y3-y1; f/=(x3-x1);
    for(i=i1;i<=i2;i++)work[i]=f*(i-x1);
  } else {
    if(k1==0 && k2==0)for(i=i1;i<=i2;i++)work[i]=(work[i]+work1[i])/2;
    if(k1)for(i=i1;i<=i2;i++)work[i]=work1[i];
  }
  if(P)printf("k1,k2: %d %d\n",k1,k2);
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
  for(i=i1;i<=i2;i++)for(j=0;j<rows;j++)bits[j-work[i]][i]=btmp[j][i];
// adjust y1,y2;  find 1st_block right_up_Y positon
  j=y1+4; i=i1+4; while(bits[j][i])i++;
  i-=4; while(bits[j][i])j--;
  k=y2-y1; y1=j+1; y2=y1+k;
}

main(int ac, char **av)
{
  int i,j,k,u,v,w, i1,i2,j1,j2, j3, ip=0;
  readpar();
  if(ac<2){
     printf("\n\t********** re_shape of pdf417 image **********\n");
     printf("\n\t                         jiang zhaoji 20111226\n");
     printf("\n\tUsage: pdfmap    file#.[bmp] [!]\n");
     printf("\n\tex:    pdfmap    c00 !");
     printf("\n\tex:    pdfmap    c#\n");
     printf("\n\toutput mc*.bmp  (next run pdfout)\n\n");
     return 0;
  }
  if(nomap)system("mkdir nomap");
  strcpy(sb,av[1]);
  for(i=0;i<strlen(sb);i++)if(sb[i]=='.')sb[i]=0;
  for(i=0;i<strlen(sb);i++)if(sb[i]=='#')sb[i]='*';
  if(XP)sprintf(sf,"dir/b %s.bmp >pdfmap.tmp",sb);
  else  sprintf(sf,"ls %s.bmp >pdfmap.tmp",sb);  system(sf);
  fp1=fopen("pdfmap.tmp","r");
  goto l100;
l99:
  if(nomap){  if(XP)sprintf(sb,"move %s nomap",sf);
               else sprintf(sb,"mv %s nomap",sf); system(sb);  }
l100:
  fgets(sf,80,fp1);  ip++;
  if(feof(fp1)){ fclose(fp1);
    if(XP)system("del pdfmap.tmp");
     else system("rm pdfmap.tmp"); return 0; }
  k=strlen(sf);  sf[k-1]=0;
  printf("%3d: %s ",ip,sf);
  fp=fopen(sf,"rb"); if(fp==0){printf(" file not found!\n"); goto l100;}
  fread(h,2,539,fp); for(i=0;i<539;i++)th[i]=h[i];
  if(h[14]!=8){ fclose(fp); printf(" not 256 grey BMP!\n"); goto l99; }
  cols=h[9]; rows=h[11]; k=(cols+3)/4*4;
  if(cols>n1)cols=n1; if(rows>n2)rows=n2;      // only take n1*n2 max picture
  for(j=0;j<n2;j++)for(i=0;i<n1;i++)bits[j][i]=0;

// add 2 false white_line, up & down,  for: get 1st & last bar position
  for(j=0;j<rows;j++)fread(obits[rows-j],1,k,fp);  fclose(fp);
  for(i=0;i<k;i++)obits[0][i]=obits[rows+1][i]=255;    // put 2 false line.
  rows+=2;
  if(P)printf("size: %d*%d\n",cols,rows);

  pre_black_edge();
//status picture case:  black & white
  for(i=0;i<cols;i++)work[i]=0;                       //  12.17 bug delete
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)work[obits[j][i]>>1]++;
  black=k=0; for(i=0;i<64;i++)if(work[i]>k){ black=i; k=work[i]; }
  if(P)printf("black: %d %d  ",black,k);
  white=k=0; for(i=64;i<128;i++)if(work[i]>k){ white=i; k=work[i]; }
  if(P)printf("white: %d %d  ",white,k);

  uninw=UNINW-black*2;
  if(uninw<20)uninw=20;  if(uninw>65)uninw=65;
  uninw+=(127-white)/2;
  dunin=20;  iturn=times=0;
  uninw-=dunin;
l00:                                                     // loop point:
  uninw+=dunin;  times++;    reduce=0;
  if(P)printf("uninw: %d\n",uninw);
  if(uninw>max_uninw || times>9){ printf("sorry, nomap\n"); goto l99; }
  oldrows=rows;
// white_black reverse, define background ~ 0
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=255-obits[j][i];

// sharpness pic, by using uninw, smooth backgroud,        sharpness WHITE
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]<uninw)bits[j][i]=0;
                                              // must not sharpness BLACK
//de_noise
  alone();                                    // de_alone pointer
// resize pic, do 3 times. due to slip tar
  j=rows/4;                                   //get bar X_length
  k=0; for(i=0;i<cols;i++){ if(bits[j][i])k++; else k=0; if(k>3)break;} x1=i-3;
  k=0; for(i=cols-1;i>0;i--){if(bits[j][i])k++;else k=0; if(k>3)break;} y1=i+3;
  j=rows/2;                                   //get bar X_length
  k=0; for(i=0;i<cols;i++){ if(bits[j][i])k++; else k=0; if(k>3)break;} x2=i-3;
  k=0; for(i=cols-1;i>0;i--){if(bits[j][i])k++;else k=0; if(k>3)break;} y2=i+3;
  j=rows/4*3;                                 //get bar X_length
  k=0; for(i=0;i<cols;i++){ if(bits[j][i])k++; else k=0; if(k>3)break;} x3=i-3;
  k=0; for(i=cols-1;i>0;i--){if(bits[j][i])k++;else k=0; if(k>3)break;} y3=i+3;
  i1=x1; if(i1>x2)i1=x2; if(i1>x3)i1=x3;
  i2=y1; if(i2<y2)i2=y2; if(i2<y3)i2=y3;
  if((x1-x2)*(x1-x2)<5 || (x2-x3)*(x2-x3)<5)i1=x2;
  if((y1-y2)*(y1-y2)<5 || (y2-y3)*(y2-y3)<5)i2=y2;
  k=i2-i1;
  if(k>expixel)goto l10;
  i1-=30; if(i1<0)i1=0; i2+=30;
  expand2(i1,i2);  oldrows=rows;              // rows, cols changed; *2-1

l10:                                          // loop pointer, for reverse pic.
// find 4 corner, roughly
  for(j=0;j<rows;j++)work[j]=0;               // project in X
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)work[j]+=bits[j][i];
  for(j=0;j<rows;j++)work[j]/=cols;
  for(j=rows/2;j>=0;j--)  if(work[j]*2<work[j+1])break; v1=j; if(v1<0)v1=0;
  for(j=rows/2;j<rows;j++)if(work[j]*2<work[j-1])break; v2=j; if(v2==rows)v2--;
  for(i=0;i<cols;i++)work[i]=0;                         // project in Y
  for(i=0;i<cols;i++)for(j=0;j<rows;j++)work[i]+=bits[j][i];
  for(i=0;i<cols;i++)work[i]/=rows;
  for(i=0;i<cols;i++)  if(work[i])break; u1=i--; if(u1<0)u1=0;
  for(i=cols-1;i>0;i--)if(work[i])break; u2=i++; if(u2==cols)u2--;
  for(i=u1;i<cols/2;i++){  k=0;                        // calculte u1,u2 more
    for(j=v1;j<v2;j++)if(bits[j][i])k++; if(k>9)break; } u1=i;
  for(i=u2;i>cols/2;i--){  k=0;
    for(j=v1;j<v2;j++)if(bits[j][i])k++; if(k>9)break; } u2=i;
  if(cols/rows >7){                                    // 2011,12,2
    k=rows/2; u=0;  v=cols-1;
    while(!bits[k][u])u++;  u--;
    while(!bits[k][v])v--;  v++;
    if(u>u1)u1=u;  if(v<u2)u2=v;
  }
//printf("u1,u2  v1,v2: %d %d    %d %d\n",u1,u2,v1,v2);
// locate 4 corner in detail
  corner(u1,v1,&x1,&y1, 1, 1);   //0,0  ------>
  corner(u1,v2,&x2,&y2, 1,-1);   // |   x1,y1         x3,y3
  corner(u2,v1,&x3,&y3,-1, 1);   // |
  corner(u2,v2,&x4,&y4,-1,-1);   // v   x2,y2         x4,y4
//printf("1,2,3,4:  %d_%d  %d_%d  %d_%d  %d_%d\n",x1,y1,x2,y2,x3,y3,x4,y4);

// check if a false_corner
  zz=false_corner(w2);           // w2:  temp only
  if(zz){                        // 2011,12,1
    if(zz==1){ x1=z1; y1=z2; }
    if(zz==2){ x2=z1; y2=z2; }
    if(zz==3){ x3=z1; y3=z2; }
    if(zz==4){ x4=z1; y4=z2; }
  }
// if reverse pic
  k=(x1+x2)/2;  u=0;   w=(y2-y1)/2;
  for(j=y1;j<y2;j++)for(i=k;i<k+w;i++)u+=bits[j][i];
  k=(x3+x4)/2;  v=0;
  for(j=y3;j<y4;j++)for(i=k-w;i<k;i++)v+=bits[j][i];
  if(u<v){  iturn++;
    if(P)printf("*** turn pic 180 degree\n");
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[rows-j-1][cols-i-1]=btmp[j][i];
    if(iturn<2)goto l10;
    u=cols-1-x1; x1=cols-1-x4; x4=u;      // 2011,12,02
    v=rows-1-y1; y1=rows-1-y4; y4=v;
    u=cols-1-x2; x2=cols-1-x3; x3=u;
    v=rows-1-y2; y2=rows-1-y3; y3=v;
  }

  wave_adjust();         // change bits[][], using x?,y? (they are fixed)
                         // effect range  max(x1,x2) -- min(x3,x4)

// workout row_direction, how may lines of code_data, ie. jbar
  for(i=0;i<rows;i++)w2[i]=0;
  for(i=0;i<cols;i++)work[i]=-1;
// 1st work out a line, then can .. work[i]-work1[i], from y1-2
  u=y1-2; if(u<0)u=0;                           // range of ybar[]
  v=y2+2; if(v>rows-1)v=rows-1;
  for(i=0;i<cols;i++)work[i]=bits[u][i];
  for(k=u+1;k<=v;k++){
    for(i=0;i<cols;i++)work1[i]=bits[k][i];
    for(i=j1=0;i<cols;i++){
      j2=work1[i]-work[i];
      if(j2<0)j2=-j2;  j1+=j2;
    } w2[k]=j1;                                 // w2: delta 2 lines differ
    for(i=0;i<cols;i++)work[i]=work1[i];        // for next line process
  }
  for(i=0;i<rows;i++)  if(w2[i])break; i1=i;
  for(i=rows-1;i>0;i--)if(w2[i])break; i2=i;
//  for(i=i1+1;i<i2;i++) if(w2[i]==0)w2[i]=1;     // avoid in range, value=0

  getybar(w2,rows,ybar,&jbar,work1);
  if(jbar<3){ printf("sorry, nomap\n"); goto l99; }
  f2=ybar[jbar-1]-ybar[0]; f2/=(jbar-1);   bargap=f2+0.5;
  if(P)printf(" jbar: %d bargap: %5.2f\n",jbar,f2);


//get each start x_position of bar[jbar][], roughly
  f2=x1-x2; f2/=(y1-y2);
  for(i=0;i<jbar;i++) xbar[i]=x1-(y1-ybar[i])*f2;
//take data  bits[rows][] --> bar[jbar][]
  for(k=0;k<jbar;k++){
    for(i=0;i<cols;i++){
      j=ybar[k];
      u=j-1; if(u<0)u=0;
      v=j+1; if(v>rows-1)v=rows-1;
      bar[k][i] =bits[j][i];
      sba1[k][i]=bits[u][i];
      sba2[k][i]=bits[v][i];

    }                      // according ybar[],  extract line ---> bar[k][i];
  }                        // may get average ybar[], according: jbar

  total=(x3-x1+x4-x2)/2+1;
  i=xbar[jbar/4]; for(j=i+9;j<cols;j++)if(!bar[jbar/4][j])break; i1=j-i;
  i=xbar[jbar/2]; for(j=i+9;j<cols;j++)if(!bar[jbar/2][j])break; i2=j-i;
  k=jbar/4*3; i=xbar[k]; for(j=i+9;j<cols;j++)if(!bar[k][j])break; w=j-i;
  v=w; if(v<i1)v=i1; if(v<i2)v=i2;
  f2=v/8.;  f2*=17;               // use first block's 8 unit, roughtly f2
  f3=(i1+i2+w)/3.-v;  if(f3<0.)f3=-f3;              // 2011,11,28
  if(f3<=2.0){  k=jbar/2;
    j=v+v+xbar[k]; while(bar[k][j])j--;
                   while(!bar[k][j])j++;
    f2=j-xbar[k];
    j=0; for(i=cols-v;i>cols/2;i--)if(bar[k][i])j++;
         else { if(j>20)break; else j=0; }
    if(i>cols*2/3){
//    printf("cols*2/3 i j f2*6/17.: %d %d %d %f\n",cols*2/3,i,j,f2*6/17.);
      if(j>f2*6/17.){  f2+=j; f2*=17./24.; }
    }
  }
  nblock=total/f2+0.5;                               // get nblock
  f2=total; f2/=(nblock*17+1);                       // detail scale: f2
  w=f2*17.+0.5;                                      // 1 block data_length
  ibar=nblock*17+1;
  if(P)printf("bar_len: %d  blocks: %d  neal_scale:%7.4f\n",total,nblock,f2);
  k=f2+0.5; if(k<4){ if(P)printf(" scale small: "); goto l00; }  // 20111223

//if backgroud too high
  if(nblock<5){      if(P)printf("blocks small: "); goto l00; }

  i1=xbar[jbar/2];
  for(v=0;v<jbar;v++){
    k=xbar[v]-i1;
    for(i=0;i<cols;i++)work[i]=bar[v][i];       //  bar[] adjust X_direction
    for(i=0;i<cols;i++)bar[v][i]=work[i+k];
    for(i=0;i<cols;i++)work[i]=sba1[v][i];      //  bar[] adjust X_direction
    for(i=0;i<cols;i++)sba1[v][i]=work[i+k];
    for(i=0;i<cols;i++)work[i]=sba2[v][i];      //  bar[] adjust X_direction
    for(i=0;i<cols;i++)sba2[v][i]=work[i+k];
    for(i=0;i<i1-2;i++)bar[v][i]=0;             // clear 2_ends
    for(i=cols-1;i>i1+total+2;i--)bar[v][i]=0;  // end,  need not clear.
  }
// re_project, calculate f2, using bar[jbar][]
// k=3: all black; k=2, black;       k=1, white,  k=0, all white
  for(i=0;i<cols;i++){
    for(j=k=0;j<jbar;j++)if(bar[j][i]>uninw+20)k++;
    if(k>=jbar-1){ work[i]=3; continue; }
    if(k<=1){ work[i]=0; continue; }
    work[i]=k>(jbar/2)?1:0;
  }
  for(i1=0;i1<cols/2;i1++)if(work[i1]>1)break;  start=i1;
  for(i2=cols-1;i2>cols/2;i2--)if(work[i2]>1)break;
  total=i2-i1+1;  f2=total; f2/=ibar;     w=f2*17.+0.5;
  if(P)printf("new_par: start: %d total %d   scale: %6.4f\n",start,total,f2);

//for(i=0;i<cols;i++){ if(i%50==0)printf("\n"); printf("%d",work[i]); }
  v=start+w;                          // sigma emergy pack,
  for(i=1;i<nblock;i++){
    j1=j2=v;
    while(work[j1]!=3)j1--;      // forback
    while(work[j2]!=3)j2++;      // forward
    if(j2-v>v-j1)j=j1; else j=j2;
    while(work[j]!=0)j--;
    xbar[i]=j;
    v=j+w;
  }
// check if left block still
  if(i2-v>w/2){  nblock++;
    if(P)printf("nblock adjusted! %d_%d ",v,w);
    j1=j2=v;
    while(work[j1]!=3)j1--;      // forback
    while(work[j2]!=3)j2++;      // forward
    if(j2-v>v-j1)j=j1; else j=j2;
    while(work[j]!=0)j--;
    xbar[i]=j;
  }
//printf("\n");for(i=1;i<nblock;i++)printf("%d ",xbar[i]);printf("\n");
  w=(xbar[1]-xbar[0])*3/4;
  for(i=2;i<nblock;i++){
    j=i-1; while(xbar[j]==0)j--;
    k=xbar[i]-xbar[j];
    if(k<w)xbar[i]=0;
  }
  for(i=j=1;i<nblock;i++)if(xbar[i])xbar[j++]=xbar[i]; nblock=j;
  j1=j2=0;
  for(i=1;i<nblock-1;i++){                   // adjust posi_error_big point
    j=xbar[i]*2-xbar[i-1]-xbar[i+1]; if(j<0)j=-j;
    if(j>j1){ j1=j; j2=i; }
  } if(j1>w/4)xbar[j2]=(xbar[j2-1]+xbar[j2+1])/2;   // bad_posi adjusted
//printf("\n");for(i=1;i<nblock;i++)printf("%d ",xbar[i]);printf("\n");

  f2=total; f2/=(nblock*17+1);               // nblock changed , cal again
  ibar=nblock*17+1;


//printf("  black: %d white: %d scale: %4.1f jbar: %d\n",black,white,f2,jbar);
  u=(120-black*2)>>2;
  for(j=0;j<jbar;j++)for(i=0;i<cols;i++)sbar[j][i]=0;
  for(j=0;j<jbar;j++){ for(i=xbar[1];i<xbar[nblock-1];i++){
    k= bar[j][i]/u; if(k<4)k=0;  sbar[j][i]=k;
    k=sba1[j][i]/u; if(k<4)k=0;  sba1[j][i]=k;
    k=sba2[j][i]/u; if(k<4)k=0;  sba2[j][i]=k;
  } sbar[j][i]=8; }

// forward adjust xbar[jbar][nblock]
  for(i=i1;i<=i2;i++){ work[i]=0; for(j=0;j<jbar;j++)if(sbar[j][i])work[i]++; }
  for(v=1;v<nblock;v++){ j=xbar[v]; while(work[j]<jbar/3)j++; xbar[v]=j; }

//printf("\n"); for(i=1;i<nblock;i++)printf("%d ",xbar[i]); printf("\n");
  j=nblock-1;
  if(xbar[j]==xbar[j-1])xbar[j]+=xbar[j-1]-xbar[j-2];
//printf("\n"); for(i=1;i<nblock;i++)printf("%d ",xbar[i]); printf("\n");


// ****** work out vertical line position
//  0: =0;  1: 7,8;   unterain: 4,5,6;   scale:  s+1, s-2;
  ntrace=0;

  for(v=1;v<nblock-1;v++){                    // work with whole block
    i1=xbar[v]; i2=xbar[v+1];   k=0;
    f3=i2-i1; f3/=17.; u=f3+0.5;   // printf(" u: %d\n",u);
/*
if(v==1){
  printf("   %d %d \n",u-2,u+1);
  for(j=0;j<jbar;j++)for(i=i1;i<i1+80;i++)printf("%x",sbar[j][i]);
//for(j=0;j<jbar;j++)for(i=i2-80;i<i2;i++)printf("%x",sbar[j][i]);
}
*/
// search white "single bar"     u-2,u+1
    for(j=0;j<jbar;j++){  w=0;
      for(i=i1+3;i<i2-9;i++){
        if(sbar[j][i]){
          if(w>=u-2 && w<=u+1)work[k++]=(i-w/2)-i1;
          w=0; continue;
        } w++;
      }
    }
// search black "single bar"      u-2,u
    for(j=0;j<jbar;j++){  w=0;
      for(i=i1+9;i<i2-3;i++){
        if(sbar[j][i]<7){
          if(w>=u-2 && w<=u  )work[k++]=(i-w/2)-i1;
          w=0; continue;
        } w++;
      }
    }
/*
if(v==1){
for(i=0;i<k;i++)printf("%d ",work[i]); printf("\n");
}
*/
// sort "single bar" position
    for(i=0;i<k-1;i++)for(j=i+1;j<k;j++)if(work[i]>work[j]){
      w=work[i]; work[i]=work[j]; work[j]=w;
    }
// combine "single bar" position.
    f4=work[0]; j=1; w=0;
    for(i=1;i<k;i++){
      if(work[i]-work[i-1]<3){  f4+=work[i]; j++; }
      else { ak[w]=j;  work[w++]=f4/j+0.5; j=1; f4=work[i]; }
    } ak[w]=j;  work[w++]=f4/j+0.5;
/*
if(v==1){
  for(i=0;i<w;i++)printf("%2d ",work[i]); printf("\n");
  for(i=0;i<w;i++)printf("%2d ",ak[i]); printf("\n");
}
*/
// check false bar, if find, delete it.
   j=k=0;
   for(i=1;i<w;i++){
     if(ak[i]==1){
       if(j==0)continue;                   // has not set standard yet
       f4=work[i]-j;
       while(f4>f3)f4-=f3;
       if(f4<1.5 || f3-f4<1.5)continue;    // no problem
       work[i]=0; k++;                     // false position find
     } else j=work[i];                     // standard position
   }
   if(k)for(i=j=0;i<w;i++)if(work[i])work[j++]=work[i];   w-=k;
/*
if(v==1){
  for(i=0;i<w;i++)printf("%d ",work[i]); printf("\n");
}
*/
// calculate "single bar" position belong 1~15 array[]
    f5=0.;  for(i=0;i<17;i++)work1[i]=0;
    for(i=0;i<w;i++){
      f4=(work[i]-f3*.5)/f3;
      j=f4+0.5+f5;  work1[j]=work[i];
      f5=j-f4;                                   // for next turn using
    }
//    printf("\n");  for(i=1;i<16;i++)printf("%2d ",work1[i]); printf("\n");
    for(i=1;i<16;i++)work[i]=f3*(i+0.5);         // standard position
                                                 // as reference only.
// for(i=1;i<16;i++)printf("%2d ",work[i]); printf("  refence\n");

// suplemented  "no single bar"  posiotin
    if(work1[1]==0){                             // for 1st point
      j=2; while(work1[j]==0)j++;
      work1[1]=work1[j]-((j-1)*f3+0.5);
      work1[1]++;                                // experience value
    }
    if(work1[15]==0){
      j=14; while(work1[j]==0)j--;               // for last point
      if(j>=13) work1[15]=work1[j]+((15-j)*f3+0.5);
      else work1[15]=work[15]-work[1]+work1[1];
    }
/*
if(v==2){
  for(i=1;i<16;i++)printf("%2d ",work1[i]); printf("  **%d\n",i2-i1);
}
*/
    for(i=2;i<15;i++){                           // for other points
      if(work1[i]==0){
        j=i+1; while(work1[j]==0)j++;   f5=j-i+1;
        work1[i]=(work1[i-1]*(j-i)+work1[j])/f5+0.5;
      }
    }

// check shift or not
   j=i2-i1-work1[15]-work1[1];

//     printf("i2-i1: %d work15: %d work1: %d u: %d  j: %d\n",
//     i2-i1,work1[15],work1[1],u,j);

   if(j>=u || work1[1]<=u ){  // printf("->");         // right_shift
     for(i=1;i<15;i++)work1[i]=work1[i+1]; work1[15]+=u;
   }
   if(j<=-u*2){  //  printf("<-");               // lefte_shift
     for(i=15;i>1;i--)work1[i]=work1[i-1]; work1[1]-=u;
   }
//    for(i=1;i<16;i++)printf("%2d ",work1[i]); printf("\n");
// save "trace" to array.
    for(i=1;i<16;i++)trace[ntrace++]=work1[i]+i1-1;
  }


// ******* bar,sbar ---> tbar
// sbar[][]= 0,4~8; bar[][]=0,uniwx~255
  for(j=0;j<jbar;j++){  i=w=0;  j3=0;           // j3 for bar blend case
    for(k=0;k<17;k++)tbar[j][i++]=h1[k];
    for(v=1;v<nblock-1;v++){
      j2=0; work[j2]=ak[j2]=255; j2++;
      for(u=0;u<15;u++){
        k=trace[w++];
        j1= sba1[j][k-1];        j1+=sba1[j][k];        j1+=sba1[j][k+1];
        j1+=sbar[j][k-1];        j1+=sbar[j][k];        j1+=sbar[j][k+1];
        j1+=sba2[j][k-1];        j1+=sba2[j][k];        j1+=sba2[j][k+1];
        ak[j2]=j1;                              // ak[]: energy
// white_hole in black:  2 sides all appear >6,
// alone black pack:     2 sides all appear 0
        j1=(sbar[j][k]>6)?1:0;
        if(j1)j1=(sbar[j][k-2]   && sbar[j][k-1])   ||
                 (sbar[j][k+2]   && sbar[j][k+1]);
        else  j1=(sbar[j][k-2]>6 || sbar[j][k-1]>6) &&
                 (sbar[j][k+2]>6 || sbar[j][k+1]>6) ;
        if(ak[j2]>p54)j1=1;                      // 9 point energy
        work[j2]=j1?255:0;
/*
if(v==1 && j==7 && u==8 ){     // u: 0~14
   printf(" v,j,u: %d %d %d energy: %d mark:%d\n",v,j,u, ak[j2],j1);
   printf("    %d %d %d\n",sba1[j][k-1],sba1[j][k],sba1[j][k+1]);
   printf("%d %d %d %d %d %d %d\n",sbar[j][k-3],sbar[j][k-2],sbar[j][k-1],
                        sbar[j][k],sbar[j][k+1],sbar[j][k+2],sbar[j][k+3]);
   printf("    %d %d %d\n",sba2[j][k-1],sba2[j][k],sba2[j][k+1]);
}
*/
        j2++;
      } work[j2]=ak[j2]=0;
      k=if4_4(work,ak,v,j);                      // check if 4_black+4_white
      if(k<1000000)j3++;
      for(k=0;k<17;k++)tbar[j][i++]=work[k];     // save trace
    }
    if(j3>1){ j--; jbar--; }                     // false bar, in blend case
    for(k=0;k<18;k++)tbar[j][i++]=h2[k];
  }

  if(P)printf("reduce:  %d\n",reduce);
  if(reduce>reduce20)goto l00;                   // 2011,12,20
// ******* write down
// find pdf417_1st_code; u=1: X_mirror swap;  v=1: swap ends block,(neednot)
  pdfswap(&u,&v);
  if(P)if(u)printf("*** pic turn 180 degree around X_axis\n");
// save data of tbar(BMP)
  w=outpic*2; v=outpic;
  sprintf(sb,"m%s",sf);
  fp=fopen(sb,"wb");
  for(i=0;i<256;i++){ th[2*i+27]=(i<<8)|i; th[2*i+28]=i; }
  th[9]=(ibar+w)*2; th[11]=(jbar+v)*2;             // 2*2 for a pointer
  fwrite(th,2,539,fp); k=(th[9]+3)/4*4;            // for check easy
  for(i=0;i<cols;i++)btmp[0][i]=255;
  for(j=0;j<v;j++)fwrite(btmp[0],1,k,fp);
  for(j=0;j<jbar;j++){                             // u==0; mirror correct
    if(u) for(i=0;i<ibar;i++)
             btmp[0][i*2+w]=btmp[0][i*2+1+w]=255-tbar[j][i];
    else for(i=0;i<ibar;i++)
             btmp[0][i*2+w]=btmp[0][i*2+1+w]=255-tbar[jbar-j-1][i];
    fwrite(btmp[0],1,k,fp);
    fwrite(btmp[0],1,k,fp);
  }
  for(i=0;i<cols;i++)btmp[0][i]=255;
  for(j=0;j<v;j++)fwrite(btmp[0],1,k,fp);
  fclose(fp);
  printf(" %d ok !\n",jbar);
//goto l100;
//}



//*****************
  if(ac<3)goto l100;
  sprintf(sb,"y%s",sf);
  out3bmp(sb,iturn,u);
  sprintf(sb,"pdfout m%s",sf); system(sb);
  goto l100;
}

cross(int x, int y, int color)               // plot cross mark.
{
  int i,j;
  for(j=y-5;j<=y+5;j++)if(j>=0 && j<n2)bits[j][x]=color;
  for(i=x-5;i<=x+5;i++)if(i>=0 && i<n1)bits[y][i]=color;
}

outbmp(char *f)
{
  FILE *fp;
  int i,j,k=(cols+3)/4*4;
// define color;
  h[535]=0xff00; h[536]=0;                     // coror 1: green
  h[533]=0;                                    // color 2: red
  fp=fopen(f,"wb");  fwrite(h,2,539,fp);
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=255-bits[j][i];
  for(j=0;j<rows;j++)fwrite(btmp[rows-j-1],1,k,fp);  fclose(fp);
}

out3bmp(char *f,int it,int ix)      // 1. bar, with trace
{                                   // 2. raw map  (iy,ix)
  FILE *fp;                         // 3. out_bar, tbar
  int i,j,k=(cols+3)/4*4,u,v,w;
  if(it){
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=obits[j][i];
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)obits[j][i]=btmp[rows-j-1][cols-i-1];
  }
  if(ix){
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=obits[j][i];
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)obits[j][i]=btmp[rows-j-1][i];
  }
// define color;
  h[535]=0xff00; h[536]=0;                     // coror 1: green
  h[533]=0;                                    // color 2: red
  h[11]=rows*2+jbar*bargap*3+8;
  fp=fopen(f,"wb");  fwrite(h,2,539,fp);
  for(i=0;i<cols;i++)btmp[0][i]=255;
  for(i=0;i<4;i++)fwrite(btmp[0],1,k,fp);
  w=f2+0.5;

// ybar
  for(v=0;v<jbar;v++)for(i=0;i<cols;i++){  j=ybar[v]; bits[j][i]=2;  }
  cross(u1,v1,2); cross(u1,v2,2); cross(u2,v1,2); cross(u2,v2,2);
  cross(x1,y1,1); cross(x2,y2,1); cross(x3,y3,1); cross(x4,y4,1);
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=255-bits[j][i];
  for(j=0;j<rows;j++)fwrite(btmp[rows-j-1],1,k,fp);

// tbar

  for(i=0;i<jbar;i++){
    for(j=0;j<cols;j++)btmp[i][j]=255;
    for(j=0;j<ibar;j++){ u=255-tbar[jbar-i-1][j];
      for(v=0;v<w;v++)btmp[i][start+j*w+v]=u;    }
    for(j=0;j<w;j++)fwrite(btmp[i],1,k,fp);
  }

// obits, due to BMP_color_plate changed, red=253, green=254, not appear
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(obits[j][i]>=253)obits[j][i]=255;
  if(ix)  for(j=0;j<rows;j++)fwrite(obits[j],1,k,fp);
  else    for(j=0;j<rows;j++)fwrite(obits[rows-j-1],1,k,fp);


//  bar with xbar
  for(i=1;i<nblock;i++){
    w=xbar[i]; for(j=0;j<jbar;j++)bar[j][w]=1;
  }
  for(i=0;i<ntrace;i++)for(j=0;j<jbar;j++)bar[j][trace[i]]=2;
  for(j=0;j<jbar;j++){
    for(v=0;v<bargap;v++){
      for(i=0;i<cols;i++)btmp[j][i]=255-bar[jbar-j-1][i];
//    for(i=0;i<ntrace;i++)btmp[j][trace[i]]=253;
      fwrite(btmp[j],1,k,fp);
    }
  }

// sbar.sba1.sba2
  for(j=0;j<jbar;j++){
    for(v=0;v<bargap;v++){
      for(i=0;i<cols;i++){
        u=sba1[jbar-j-1][i]<<5; if(u>255)u=255;
        btmp[j][i]=255-u;
      }
      fwrite(btmp[j],1,k,fp);
    }
  }

  for(i=0;i<cols;i++)btmp[0][i]=255;
  for(i=0;i<4;i++)fwrite(btmp[0],1,k,fp);
  fclose(fp);
}

test1(){  printf("out raw b.bmp only!\n"); outbmp("b.bmp");   exit(0);}

test2()
{
  printf("out cross b.bmp only!\n");
  if(zz)cross(z1,z2, 2);
  cross(u1,v1,2);  cross(u1,v2,2);  cross(u2,v1,2);  cross(u2,v2,2);
  cross(x1,y1,1);  cross(x2,y2,1);  cross(x3,y3,1);  cross(x4,y4,1);
  outbmp("b.bmp");
  exit(0);
}

